#<profile4xi profile = "11" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3200three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 3200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3200three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three32004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three32004xi = {
                1 :  '0x3106y-769z',
                2 :  '100x2878y-1394z',
                3 :  '1011x2780y-1219z',
                4 :  '1042x2582y-1575z',
                5 :  '1046x769y-2924z',
                6 :  '1048x2364y-1884z',
                7 :  '105x102y-3196z',
                8 :  '10x126y-3197z',
                9 :  '10x15y-3199z',
                10 :  '1109x729y-2911z',
                11 :  '1129x2942y-550z',
                12 :  '1160x2734y-1189z',
                13 :  '1179x2323y-1858z',
                14 :  '1182x2539y-1547z',
                15 :  '122x294y-3184z',
                16 :  '127x837y-3085z',
                17 :  '1284x2884y-518z',
                18 :  '128x2521y-2124z',
                19 :  '1307x2680y-1160z',
                20 :  '1308x2274y-1832z',
                21 :  '1320x2487y-1519z',
                22 :  '134x118y-3194z',
                23 :  '1435x2217y-1805z',
                24 :  '1435x2817y-487z',
                25 :  '1451x2618y-1130z',
                26 :  '1456x2427y-1491z',
                27 :  '151x316y-3180z',
                28 :  '1559x2154y-1779z',
                29 :  '1583x2743y-455z',
                30 :  '1590x2360y-1462z',
                31 :  '1592x2548y-1100z',
                32 :  '162x3109y-738z',
                33 :  '165x131y-3193z',
                34 :  '1681x2083y-1752z',
                35 :  '1720x2285y-1434z',
                36 :  '1727x2660y-423z',
                37 :  '1729x2470y-1070z',
                38 :  '177x860y-3077z',
                39 :  '1799x2005y-1725z',
                40 :  '183x335y-3177z',
                41 :  '1846x2203y-1405z',
                42 :  '185x2679y-1739z',
                43 :  '1863x2384y-1040z',
                44 :  '1866x2569y-391z',
                45 :  '1914x1920y-1698z',
                46 :  '1968x2113y-1376z',
                47 :  '198x140y-3190z',
                48 :  '1992x2291y-1009z',
                49 :  '2001x2471y-360z',
                50 :  '2024x1829y-1671z',
                51 :  '2086x2017y-1347z',
                52 :  '2116x2191y-979z',
                53 :  '2129x2365y-328z',
                54 :  '2130x1731y-1644z',
                55 :  '217x352y-3173z',
                56 :  '2199x1913y-1318z',
                57 :  '21x157y-3196z',
                58 :  '2231x1626y-1616z',
                59 :  '2235x2084y-948z',
                60 :  '2253x2253y-296z',
                61 :  '2306x1804y-1289z',
                62 :  '230x879y-3068z',
                63 :  '2348x1970y-918z',
                64 :  '2369x2133y-264z',
                65 :  '2408x1688y-1260z',
                66 :  '2455x1850y-887z',
                67 :  '2480x2008y-232z',
                68 :  '252x2882y-1365z',
                69 :  '253x366y-3168z',
                70 :  '254x2455y-2035z',
                71 :  '2556x1724y-856z',
                72 :  '2583x1877y-200z',
                73 :  '285x895y-3058z',
                74 :  '291x378y-3164z',
                75 :  '2x95y-3198z',
                76 :  '30x41y-3199z',
                77 :  '326x3103y-707z',
                78 :  '328x2683y-1712z',
                79 :  '331x386y-3159z',
                80 :  '342x907y-3049z',
                81 :  '35x187y-3194z',
                82 :  '36x784y-3102z',
                83 :  '373x391y-3153z',
                84 :  '385x2459y-2011z',
                85 :  '401x916y-3039z',
                86 :  '404x2879y-1336z',
                87 :  '416x392y-3148z',
                88 :  '45x2667y-1766z',
                89 :  '460x390y-3142z',
                90 :  '462x921y-3029z',
                91 :  '470x2678y-1685z',
                92 :  '489x3089y-675z',
                93 :  '504x385y-3136z',
                94 :  '517x2455y-1986z',
                95 :  '525x921y-3018z',
                96 :  '52x216y-3192z',
                97 :  '53x64y-3198z',
                98 :  '550x375y-3129z',
                99 :  '557x2866y-1307z',
                100 :  '589x918y-3008z',
                101 :  '614x2666y-1658z',
                102 :  '650x2443y-1960z',
                103 :  '651x3065y-644z',
                104 :  '653x910y-2997z',
                105 :  '709x2846y-1278z',
                106 :  '719x898y-2985z',
                107 :  '73x244y-3189z',
                108 :  '757x2646y-1630z',
                109 :  '77x84y-3197z',
                110 :  '783x2424y-1935z',
                111 :  '785x882y-2974z',
                112 :  '80x812y-3094z',
                113 :  '812x3033y-613z',
                114 :  '851x860y-2962z',
                115 :  '861x2817y-1249z',
                116 :  '900x2618y-1603z',
                117 :  '916x2398y-1909z',
                118 :  '916x835y-2949z',
                119 :  '96x270y-3187z',
                120 :  '972x2992y-581z',
                121 :  '982x804y-2937z'  
                }
            
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire3200three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire3200three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3200THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3200THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3200THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE3200THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3200THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three32004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3200THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3200THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3200THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL  
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three32004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three32004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3200THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())  
            # SENT MESSAGE2SEND4THREE:  <ack2put4xi>queue2three8shot2three32004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2THREE:  <read-write PipeConnection, handle 276>  - TIME:  03:57:19 08/31/10 Pacific Daylight Time
 
        
    except:
        print(" (STEP 3C/33) OF FIRE3200THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3200THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3200three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                